Index: pjproject/trunk/aconfigure.ac
===================================================================
--- pjproject/trunk/aconfigure.ac	(revision 3057)
+++ pjproject/trunk/aconfigure.ac	(revision 3058)
@@ -389,4 +389,28 @@
 	      )
 
+dnl # PortAudio path. If ac_pa_path is not empty, we're using PortAudio
+dnl # in external location (not under third_party)
+AC_SUBST(ac_pa_path)
+AC_ARG_WITH(pa-path,
+    AC_HELP_STRING([--with-pa-path=DIR],
+		   [Specify PortAudio alternate location (e.g. /usr). When this option is set, we will not use our copy of PortAudio in third_party directory.]),
+    [
+	if test "x$with_pa_path" != "xno"; then
+		ac_pa_path=$with_pa_path
+		# Remove trailing backslash
+		ac_pa_path=`echo $ac_pa_path | sed 's/\/$//'`
+		# Test the path
+    		#if test ! -f $ac_pa_path/include/portaudio.h; then
+		#	AC_MSG_ERROR([Wrong --with-pa-path value, $ac_pa_path/include/portaudio.h does not exist])
+		#fi
+    		#if test ! -d $ac_pa_path/lib; then
+		#	AC_MSG_ERROR([Wrong --with-pa-path value, $ac_pa_path/lib does not exist])
+		#fi
+		AC_MSG_RESULT([** Using PortAudio in $ac_pa_path **])
+	fi
+    ]
+    )
+
+
 AC_SUBST(ac_pa_cflags)
 AC_CHECK_HEADER(sys/soundcard.h,
Index: pjproject/trunk/build.mak.in
===================================================================
--- pjproject/trunk/build.mak.in	(revision 3057)
+++ pjproject/trunk/build.mak.in	(revision 3058)
@@ -34,7 +34,13 @@
 endif
 
+ifneq (x@ac_pa_path@,x)
+# We're using external PortAudio
+APP_THIRD_PARTY_LIBS += -L@ac_pa_path@/lib -lportaudio
+APP_THIRD_PARTY_LIB_FILES += 
+else
 ifneq ($(findstring pa,@ac_pjmedia_snd@),)
 APP_THIRD_PARTY_LIBS += -lportaudio-$(TARGET_NAME)
 APP_THIRD_PARTY_LIB_FILES += $(PJ_DIR)/third_party/lib/libportaudio-$(LIB_SUFFIX)
+endif
 endif
 
Index: pjproject/trunk/pjmedia/build/Makefile
===================================================================
--- pjproject/trunk/pjmedia/build/Makefile	(revision 3057)
+++ pjproject/trunk/pjmedia/build/Makefile	(revision 3058)
@@ -2,5 +2,4 @@
 
 THIRD_PARTY:=$(PJDIR)/third_party
-PA_DIR := $(THIRD_PARTY)/build/portaudio/src
 
 SRTP_INC=$(CC_INC)$(THIRD_PARTY)/build/srtp \
Index: pjproject/trunk/pjmedia/build/os-auto.mak.in
===================================================================
--- pjproject/trunk/pjmedia/build/os-auto.mak.in	(revision 3057)
+++ pjproject/trunk/pjmedia/build/os-auto.mak.in	(revision 3058)
@@ -87,5 +87,11 @@
 #
 ifneq ($(findstring pa,$(AC_PJMEDIA_SND)),)
+ifeq (x@ac_pa_path@,x)
+# Our PA in third_party
 export CFLAGS += -I$(THIRD_PARTY)/build/portaudio -I$(THIRD_PARTY)/portaudio/include -DPJMEDIA_AUDIO_DEV_HAS_PORTAUDIO=1
+else
+# External PA
+export CFLAGS += -I@ac_pa_path@/include -DPJMEDIA_AUDIO_DEV_HAS_PORTAUDIO=1
+endif
 endif
 
Index: pjproject/trunk/pjmedia/src/pjmedia-audiodev/pa_dev.c
===================================================================
--- pjproject/trunk/pjmedia/src/pjmedia-audiodev/pa_dev.c	(revision 3057)
+++ pjproject/trunk/pjmedia/src/pjmedia-audiodev/pa_dev.c	(revision 3058)
@@ -31,4 +31,9 @@
 #define DRIVER_NAME	"PA"
 
+/* Enable call to PaUtil_SetDebugPrintFunction, but this is not always
+ * available across all PortAudio versions (?)
+ */
+/*#define USE_PA_DEBUG_PRINT */
+
 struct pa_aud_factory
 {
@@ -405,4 +410,5 @@
 }
 
+#ifdef USE_PA_DEBUG_PRINT
 /* Logging callback from PA */
 static void pa_log_cb(const char *log)
@@ -416,4 +422,5 @@
 typedef void (*PaUtilLogCallback ) (const char *log);
 void PaUtil_SetDebugPrintFunction(PaUtilLogCallback  cb);
+#endif
 
 
@@ -443,5 +450,7 @@
     PJ_UNUSED_ARG(f);
 
+#ifdef USE_PA_DEBUG_PRINT
     PaUtil_SetDebugPrintFunction(&pa_log_cb);
+#endif
 
     err = Pa_Initialize();
Index: pjproject/trunk/third_party/build/os-auto.mak.in
===================================================================
--- pjproject/trunk/third_party/build/os-auto.mak.in	(revision 3057)
+++ pjproject/trunk/third_party/build/os-auto.mak.in	(revision 3058)
@@ -16,6 +16,9 @@
 endif
 
+ifeq (x@ac_pa_path@,x)
+# Only if we're using our own PA in third_party
 ifneq ($(findstring pa,@ac_pjmedia_snd@),)
 DIRS += portaudio
 endif
+endif
 
